//--------------------------------------------------------------//
// ARGBToBGR
//
// Copyright (c) LWKS Software Ltd.  All Rights Reserved
//--------------------------------------------------------------//
DeclareLightworksEffect( ARGBToBGR, Internal, Colour, kNoNotes, kNoFlags );

DeclareInput( Input, Point );

DeclareFloatParam( _Width );

DeclareEntryPoint()
{
   float4 ret;

   // which group?
   int x = (int) (fmod( uv1.x * _Width, 3.0 ));

   if ( x == 0 )
   {
      float4 src = tex2D( Input, uv1 );
      float4 srcr = tex2D( Input, uv2 );

      ret.b = src.b;
      ret.g = src.g;
      ret.r = src.r;
      ret.a = srcr.b;
   }
   else if ( x == 1 )
   {
      // 1/3 through a pixel
      //uv1.x -= 1.0 / (3.0 * _Width);
      //uv2.x -= 1.0 / (3.0 * _Width);

      float4 src = tex2D( Input, uv1 );
      float4 srcr = tex2D( Input, uv2 );

      ret.b = src.g;
      ret.g = src.r;
      ret.r = srcr.b;
      ret.a = srcr.g;
   }
   else if ( x == 2 )
   {
      // 2/3 of the way through the pixel - we would sample the next 2 pixels instead (or suchlike)
      uv1.x -= 2.0 / (3.0 * _Width);
      uv2.x -= 2.0 / (3.0 * _Width);

      float4 src = tex2D( Input, uv1 );
      float4 srcr = tex2D( Input, uv2 );

      ret.b = src.r;
      ret.g = srcr.b;
      ret.r = srcr.g;
      ret.a = srcr.r;
   }

   return ret;
}

