//--------------------------------------------------------------
// BGRToARGB
//
// Copyright (c) LWKS Software Ltd.  All Rights Reserved
//--------------------------------------------------------------
DeclareLightworksEffect( Null, Internal, Colour, kNoNotes, kNoFlags );

DeclareInput( Input, Point );

DeclareFloatParam( _Width );

DeclareEntryPoint()
{
   float4 ret;

   float2 uvr;

   // shift a quarter pixel right
   uvr.x = uv1.x + 0.25 / _Width;
   uvr.y = uv1.y;

   int x = ( int ) fmod( uv1.x * _Width, 4 );

   if ( x == 0 )
   {
      float4 src = tex2D( Input, uvr );

      ret.b = src.r;
      ret.g = src.g;
      ret.r = src.b;
   }
   else if ( x == 1 )
   {
      float4 srcl = tex2D( Input, uv2 );
      float4 srcr = tex2D( Input, uvr );

      ret.b = srcr.g;
      ret.g = srcr.b;
      ret.r = srcl.a;
   }
   else if ( x == 2 )
   {
      float4 srcl = tex2D( Input, uv2 );
      float4 srcr = tex2D( Input, uvr );

      ret.b = srcr.b;
      ret.g = srcl.a;
      ret.r = srcl.r;
   }
   else if ( x == 3 )
   {
      float4 src = tex2D( Input, uvr );

      ret.b = src.a;
      ret.g = src.r;
      ret.r = src.g;
   }

   ret.a = 1.;

   return ret;
}
