//--------------------------------------------------------------//
// RGB16ToABGR
//
// Copyright (c) LWKS Software Ltd.  All Rights Reserved
//--------------------------------------------------------------//
DeclareLightworksEffect( RGB16ToABGR, Internal, Colour, kNoNotes, kNoFlags );

DeclareInput( Input, Clamp, Point );

DeclareFloatParam( _Width );

DeclareEntryPoint()
{
   float4 ret;

   float2 uv1r;

   // shift a quarter pixel right
   uv1r.x = uv1.x + 0.25 / _Width;
   uv1r.y = uv1.y;

   int x = (int) fmod( uv1.x * _Width, 4 );

   if ( x == 0 )
   {
      float4 src = tex2D( Input, uv1r );

      ret.r = src.b;
      ret.g = src.g;
      ret.b = src.r;
   }
   else if ( x == 1 )
   {
      float4 srcl = tex2D( Input, uv2 );
      float4 srcr = tex2D( Input, uv1r );

      ret.r = srcr.g;
      ret.g = srcr.r;
      ret.b = srcl.a;
   }
   else if ( x == 2 )
   {
      float4 srcl = tex2D( Input, uv2 );
      float4 srcr = tex2D( Input, uv1r );

      ret.r = srcr.r;
      ret.g = srcl.a;
      ret.b = srcl.b;
   }
   else if ( x == 3 )
   {
      float4 src = tex2D( Input, uv1r );

      ret.b = src.a;
      ret.g = src.b;
      ret.r = src.g;
   }

   ret.a = 1.;

   return ret;
}
